#include "string.h"
#include <os.h>

void itoa (char *buf, unsigned int n, int base)
{
    unsigned int tmp;
    int i = 0, j;

    do
    {
        tmp = n % base;
        buf[i++] = (tmp < 10) ? (tmp + '0') : (tmp + 'A' - 10);
    } while (n /= base);
    buf[i--] = 0;

    for (j = 0; j < i; ++j, --i)
    {
        tmp = buf[j];
        buf[j] = buf[i];
        buf[i] = tmp;
    }
}

int strlen (char *s)
{
    int i = 0;
    while (*s++) i++;
    return i;
}

char *strcpy(char *dest, char *src)
{
   char *save = dest;
   while(*dest++ = *src++);
   return save;
}

int strcmp(char * s1, char * s2)
{
  for(; *s1 == *s2; ++s1, ++s2)
    if(*s1 == 0)
      return 0;
  return *(unsigned char *)s1 < *(unsigned char *)s2 ? -1 : 1;
}

int atoi(char* str)
{
  int n, i, l;
  l = strlen(str);
  n = 0;
  for (i = 0; i < l; i++) {
    if (str[i] == '-') continue;
    n = 10 * n + (str[i] - '0');
  } 
  if (str[0] == '-') n = -n;
  return n;
}
